/*
 * main.c
 *
 * Last modified: <2009/10/17 18:02:27 +0900> By SUMIDA
 */
#include <SDL.h>
#include <math.h>

#include "main.h"
#include "draw.h"
#include "font.h"
#include "sound.h"
#include "input.h"
#include "log.h"

#define NUMBEROF(_array) (sizeof(_array)/sizeof(_array[0]))

/* 1ubÑTCY */
#define BLOCK_W  24
#define BLOCK_H  24

/* tB[h̃TCY */
#define FIELD_W  10
#define FIELD_H  (20+1)

#define RATE_INTERVAL 4
#define HURRYUP_LINE  (FIELD_H-13)

/* tB[h̕\Jnʒu */
#define FIELD_OX  ((WIDTH  - (BLOCK_W * FIELD_W) - LINE_W * 2) / 2)
#define FIELD_OY  ((HEIGHT - (BLOCK_H * FIELD_H) - LINE_W) / 2)

/* eg~m̕\ʒu */
#define NEXT_MINO_X   (FIELD_W)
#define NEXT_MINO_Y   2

/* ڒ܂ł̗Vю */
#define BOND_WAIT     30

/* xAbvJEg */
#define LEVELUP_COUNT   5 /**/
/*#define LEVELUP_COUNT  10 /**/

/* {JEg */
#define BASE_DOWN_COUNT  60 /**/
/*#define BASE_DOWN_COUNT  100 /**/

/* x␳l */
#define FIXED_LEVEL     20

/* C */
#define LINE_W  8

/* C̐F */
#define LINE_COLOR  0x000000

/* wi̐F */
#define BACK_COLOR  0xFFFFFF

#define RATE4_COLOR 0xFFF0F0
#define RATE3_COLOR 0xFFFFC0
#define RATE2_COLOR 0xF0FFF0

/* tHg̕\ʒu */
#define TITLE_ROW      1
#define TITLE_COL      1
#define START_ROW     10
#define START_COL      4
#define GAMEOVER_ROW  12
#define GAMEOVER_COL  12
#define STATUS1_COL    1
#define STATUS2_COL   23
#define NEXT_ROW       2
#define SCORE_ROW      4
#define LINES_ROW      7
#define LEVEL_ROW     10
#define POINTS_ROW    24
#define POINTS_COL     7

/* tHg̃TCY */
#define FONT_SIZE_W   24
#define FONT_SIZE_H   24

/* tHgt@C */
static const char *font_name = "font24x24_blue.bmp";


/* ubN̐Fԍ */
enum {
	R = 1,/*  */
	Y,    /*  */
	P,    /*  */
	G,    /*  */
	B,    /*  */
	O,    /*  */
	W,    /*  */
	H,    /* D */
	COLOR_MAX
};

/* ubN̐F */
unsigned int bcolors[] = {
	0x000000,
	0xff0000,
	0xffff00,
	0xff00ff,
	0x00ff00,
	0x0000ff,
	0xffc000,
	0xc0c0ff,
	0x606060,
};

/* eg~m\ */
typedef struct TETORIMINO {
	char *name;
	char *patterns;
	char pmax;
	char size;
	char sx, sy;
} TETORIMINO;

/* eg~m̒`
 * QlFhttp://www.tetrisivorytower.com/modules/xpwiki/197.html
 */
static char i_patterns[] = {
	0,0,0,0,
	R,R,R,R,
	0,0,0,0,
	0,0,0,0,

	0,0,R,0,
	0,0,R,0,
	0,0,R,0,
	0,0,R,0,
};

static TETORIMINO i_mino = {
	"I mino",
	i_patterns,
	2,
	4,
	3, -1,
};


static char o_patterns[] = {
	Y,Y,
	Y,Y,
};

static TETORIMINO o_mino = {
	"O mino",
	o_patterns,
	1,
	2,
	4, 0,
};


static char s_patterns[] = {
	0,0,0,
	0,P,P,
	P,P,0,

	P,0,0,
	P,P,0,
	0,P,0,
};

static TETORIMINO s_mino = {
	"S mino",
	s_patterns,
	2,
	3,
	4, -1,
};


static char z_patterns[] = {
	0,0,0,
	G,G,0,
	0,G,G,

	0,0,G,
	0,G,G,
	0,G,0,
};

static TETORIMINO z_mino = {
	"Z mino",
	z_patterns,
	2,
	3,
	4, -1,
};

static char j_patterns[] = {
	0,0,0,
	B,B,B,
	0,0,B,

	0,B,B,
	0,B,0,
	0,B,0,

	0,0,0,
	B,0,0,
	B,B,B,

	0,B,0,
	0,B,0,
	B,B,0,
};

static TETORIMINO j_mino = {
	"J mino",
	j_patterns,
	4,
	3,
	4, -1,
};


static char l_patterns[] = {
	0,0,0,
	O,O,O,
	O,0,0,

	0,O,0,
	0,O,0,
	0,O,O,

	0,0,0,
	0,0,O,
	O,O,O,

	O,O,0,
	0,O,0,
	0,O,0,
};

static TETORIMINO l_mino = {
	"L mino",
	l_patterns,
	4,
	3,
	4, -1,
};


static char t_patterns[] = {
	0,0,0,
	W,W,W,
	0,W,0,

	0,W,0,
	0,W,W,
	0,W,0,

	0,0,0,
	0,W,0,
	W,W,W,

	0,W,0,
	W,W,0,
	0,W,0,
};

static TETORIMINO t_mino = {
	"T mino",
	t_patterns,
	4,
	3,
	4, -1,
};


static TETORIMINO *minos[] = {
	&i_mino,
	&o_mino,
	&s_mino,
	&z_mino,
	&j_mino,
	&l_mino,
	&t_mino,
};

static int points[] = {100, 300, 500, 1000};

enum {
	BGM_TITLE = 0,
	BGM_GAME,
	BGM_HURRYUP,
	BGM_GAMEOVER,
	BGM_RANKING,
	BGM_MAX
};

enum {
	SE_BUTTON = 0,
	SE_DOWN,
	SE_ERASE,
	SE_TETORIS,
	SE_MAX
};

/* ubN` */
static void draw_block(unsigned int frameBuf[HEIGHT][WIDTH],
					   int x, int y, int cno);

/* eg~m̕` */
static void draw_tetorimino(unsigned int frameBuf[HEIGHT][WIDTH],
					 int x, int y, int mino, int rot);

/* ̃eg~m */
static void next_mino(void);

/* ubÑ^C}ݒ */
static void reset_btimer(void);

/* tB[hƂ̐ڐG */
static int check_field(int x, int y, int mino, int rot);

/* tB[hɃeg~mݒ */
static void set_tetorimino(int x, int y, int mino, int rot);

/* C̔ */
static int check_line(int y, int mino, int rot);

/* C */
static void clear_line(void);

/* Zbg */
static void reset(void);

/* V[Ǘԍ */
SCENE_ID scene_id = SCENE_ID_TITLE;

/* tB[h̏ */
char field[FIELD_H][FIELD_W];

unsigned char mino_mask;

int bx, by;  /* ubN̈ʒu       */
int mino;    /* eg~m̔ԍ     */
int next;    /* ̃eg~m̔ԍ */
int rot;     /* ]                 */
int btimer;  /* ubN̗^C} */
int wtimer;  /* ubN̑҂^C} */
int tline;   /* ŏʂ̃C       */

unsigned int score; /* XRA       */
unsigned int lines; /* C */
unsigned int level; /* x       */
unsigned int line4; /* SC */
unsigned int line3; /* RC */
unsigned int line2; /* QC */
unsigned int line1; /* PC */
unsigned int count; /* oeg~m     */
int levelup_cnt;

char clear_tbl[4];
int clear_cnt;

/*  */
int game_init(void) {

	REPORT("game_init ... start.");

	/* ͐̏ */
	input_init();

	/* tHg̏ */
	font_init(font_name, FONT_SIZE_W, FONT_SIZE_H);

	/* TEh̏ */
	sound_init(BGM_MAX, SE_MAX);
	sound_load_music("homepage2.nifty.com\\musmus\\music\\loop001.wav", BGM_TITLE);
	sound_load_music("homepage2.nifty.com\\musmus\\music\\loop005.wav", BGM_GAME);
	sound_load_music("homepage1.nifty.com\\mikubo\\loop\\loop008.wav", BGM_HURRYUP);
	sound_load_music("homepage1.nifty.com\\mikubo\\loop\\loop010.wav", BGM_GAMEOVER);
	sound_load_music("homepage2.nifty.com\\musmus\\music\\loop002.wav", BGM_RANKING);
	sound_load_effect("utm-game-web.hp.infoseek.co.jp\\sound\\sound2\\poko.wav", SE_BUTTON);
	sound_load_effect("utm-game-web.hp.infoseek.co.jp\\sound\\sound2\\gun.wav", SE_DOWN);
	sound_load_effect("utm-game-web.hp.infoseek.co.jp\\sound\\sound2\\pan3.wav", SE_ERASE);
	sound_load_effect("utm-game-web.hp.infoseek.co.jp\\sound\\sound2\\zasizasi.wav", SE_TETORIS);

	/*  */
	randomize();

	reset();

	REPORT("game_init ... done.");

	return 0;
}

/* I */
void game_term(void) {

	REPORT("game_term ... start.");

	/* tHg̔j */
	font_term();

	/* TEh̔j */
	sound_term();

	/* ͐̔j */
	input_term();

	REPORT("game_term ... done.");
}

/* XV */
void game_update(void) {

	input_read();

	font_locate(TITLE_COL, TITLE_ROW);
	font_printf(TITLE);

	/* V[̏ */
	switch (scene_id) {
	case SCENE_ID_TITLE:
		if (input[P1] & INPUT_KEYDOWN_SPACE) {
			scene_id = SCENE_ID_GAME;
			sound_music(BGM_GAME, -1);
			font_locate(START_COL, START_ROW);
			font_printf("                         ");
		}
		return;

	case SCENE_ID_OVER:
		if (btimer >= 0) {
			char *p = field[btimer];
			int i;
			for (i = 0; i < FIELD_W; i++) {
				if (p[i]) p[i] = H;
			}
			if (btimer) {
				sound_effect(SE_DOWN);
			} else {
				sound_effect(SE_ERASE);
				sound_music(BGM_GAMEOVER, -1);
			}
			--btimer;
		}
		font_locate(GAMEOVER_COL, GAMEOVER_ROW);
		font_printf("GAME OVER");
		if (input[P1] & INPUT_KEYDOWN_SPACE) {
			reset();
		}
		return;

	default:
		break;
	}

	/* Cxg̏ */
	if ((input[P1] & INPUT_PRESS_DOWN) && mino >= 0) {
		/* L[ꍇ́AubN悤Ƀ^C}NA */
		btimer = 0;
	}

	/* Ԃ牺Ɉړ */
	if (btimer-- <= 0) {

		/* L[GbWݒ */
		Uint32 key = input[P1] & (INPUT_PRESS_LEFT|INPUT_PRESS_RIGHT);
		key <<= 8, input[P1] |= key;
		key <<= 8, input[P1] |= key;

		btimer = 0;

		if (mino >= 0) {
			if (check_field(bx, by + 1, mino, rot) == 0) {
				if (input[P1] & INPUT_PRESS_DOWN) ++score;
				reset_btimer();
				++by;

				if (check_field(bx, by + 1, mino, rot) != 0) {
					/* Xɉɂ̓ubNꍇAxƊ֌WȂɐڒn҂ */
					sound_effect(SE_DOWN);
					wtimer = BOND_WAIT;
				}

			} else if (wtimer-- <= 0) {
				/* ړłȂꍇŎԂH */
				set_tetorimino(bx, by, mino, rot);
				if (check_line(by, mino, rot) > 0) btimer = BOND_WAIT;
				mino = -1;
			}

		} else {
			if (clear_cnt > 0) {
				clear_line();
			}

			/* ̃eg~mpӂ */
			reset_btimer();
			next_mino();

			if (check_field(bx, by, mino, rot) != 0) {
				/* Q[I[o[ */
				set_tetorimino(bx, by, mino, rot);
				scene_id = SCENE_ID_OVER;
				btimer = FIELD_H - 1;
			}
		}
	}

	/* L[ɂ鏈 */
	if (mino >= 0) {
		TETORIMINO *m = minos[mino];
		int action = 0;

		/* ] */
		if (input[P1] & (INPUT_KEYDOWN_SPACE|INPUT_KEYDOWN_BUTTON1)) {
			int r = (rot + 1) % m->pmax;
			if (check_field(bx, by, mino, r) == 0) rot = r, action = 1;
		}
		if (input[P1] & (INPUT_KEYDOWN_SELECT|INPUT_KEYDOWN_BUTTON2)) {
			int r = (rot + m->pmax - 1) % m->pmax;
			if (check_field(bx, by, mino, r) == 0) rot = r, action = 1;
		}

		/* ʒu߂ */
		if (input[P1] & INPUT_KEYDOWN_RIGHT) {
			int v = bx + 1;
			if (check_field(v, by, mino, rot) == 0) bx = v, action = 1;
		}

		if (input[P1] & INPUT_KEYDOWN_LEFT) {
			int v = bx - 1;
			if (check_field(v, by, mino, rot) == 0) bx = v, action = 1;
		}

		if (action && wtimer < 0 && check_field(bx, by + 1, mino, rot) != 0) {
			/* Xɉɂ̓ubNꍇAxƊ֌WȂɐڒn҂ */
			sound_effect(SE_DOWN);
			wtimer = BOND_WAIT;
		}
	}

	/* eLXg̔zu */
	font_locate(STATUS1_COL, SCORE_ROW);
	font_printf("SCORE");
	font_locate(STATUS1_COL, SCORE_ROW+1);
	font_printf("% 9d", score);
	font_locate(STATUS1_COL, LINES_ROW);
	font_printf("LINES");
	font_locate(STATUS1_COL, LINES_ROW+1);
	font_printf("% 9d", lines);
	font_locate(STATUS1_COL, LEVEL_ROW);
	font_printf("LEVEL");
	font_locate(STATUS1_COL, LEVEL_ROW+1);
	font_printf("% 9d", level);

	font_locate(STATUS2_COL, NEXT_ROW);
	font_printf("NEXT");
	/*font_printf(" %4d", btimer); /**/

	font_locate(STATUS2_COL, 7);
	font_printf("4LINES");
	font_locate(STATUS2_COL, 8);
	font_printf("% 9d", line4);
	font_locate(STATUS2_COL, 10);
	font_printf("3LINES");
	font_locate(STATUS2_COL, 11);
	font_printf("% 9d", line3);
	font_locate(STATUS2_COL, 13);
	font_printf("2LINES");
	font_locate(STATUS2_COL, 14);
	font_printf("% 9d", line2);
	font_locate(STATUS2_COL, 16);
	font_printf("1LINES");
	font_locate(STATUS2_COL, 17);
	font_printf("% 9d", line1);
}

/* ʕ`揈 */
void game_draw(unsigned int frameBuf[HEIGHT][WIDTH]) {

	TETORIMINO *nm = minos[next];
	int x, y;

	/* wi̐F` */
	SDL_FillRect(screen, NULL, BACK_COLOR);

	/* tB[hwi` */
	draw_rect(frameBuf,
			  FIELD_OX -1,
			  FIELD_OY + BLOCK_H,
			  FIELD_OX + BLOCK_W * FIELD_W -1,
			  FIELD_OY + BLOCK_H + BLOCK_H * RATE_INTERVAL * 2 -1,
			  RATE4_COLOR);

	draw_rect(frameBuf,
			  FIELD_OX -1,
			  FIELD_OY + BLOCK_H + BLOCK_H * RATE_INTERVAL * 2,
			  FIELD_OX + BLOCK_W * FIELD_W -1,
			  FIELD_OY + BLOCK_H + BLOCK_H * RATE_INTERVAL * 3 -1,
			  RATE3_COLOR);

	draw_rect(frameBuf,
			  FIELD_OX -1,
			  FIELD_OY + BLOCK_H + BLOCK_H * RATE_INTERVAL * 3,
			  FIELD_OX + BLOCK_W * FIELD_W -1,
			  FIELD_OY + BLOCK_H + BLOCK_H * RATE_INTERVAL * 4 -1,
			  RATE2_COLOR);

	/* ubN̘g\ */
	draw_rect(frameBuf,
			  FIELD_OX - LINE_W -1,
			  FIELD_OY + BLOCK_H,
			  FIELD_OX -2,
			  FIELD_OY + BLOCK_H * FIELD_H + LINE_W -1,
			  LINE_COLOR);

	draw_rect(frameBuf,
			  FIELD_OX + BLOCK_W * FIELD_W,
			  FIELD_OY + BLOCK_H,
			  FIELD_OX + BLOCK_W * FIELD_W + LINE_W -1,
			  FIELD_OY + BLOCK_H * FIELD_H + LINE_W -1,
			  LINE_COLOR);

	draw_rect(frameBuf,
			  FIELD_OX -1,
			  FIELD_OY + BLOCK_H * FIELD_H,
			  FIELD_OX + BLOCK_W * FIELD_W,
			  FIELD_OY + BLOCK_H * FIELD_H + LINE_W -1,
			  LINE_COLOR);

	/* ςݏオĂubN\ */
	for (y = 0; y < FIELD_H; y++) {
		char *p = field[y];

		for (x = 0; x < FIELD_W; x++) {
			char m = *p++;

			if (m > 0) {
				draw_block(frameBuf, x, y, m);
			}
		}
	}

	if (scene_id != SCENE_ID_TITLE) {
		/* ̃ubN\ */
		draw_tetorimino(frameBuf,
						NEXT_MINO_X + nm->sx, NEXT_MINO_Y + nm->sy,
						next, 0);

		if (scene_id == SCENE_ID_GAME && mino >= 0) {
			/* \ȃubN\ */
			draw_tetorimino(frameBuf, bx, by, mino, rot);
		}
	}

	/* tHgʂ̕` */
	font_draw();
}

/* ubN̕` */
void draw_block(unsigned int frameBuf[HEIGHT][WIDTH],
				int x, int y, int cno) {

	int fx = FIELD_OX + x * BLOCK_W;
	int fy = FIELD_OY + y * BLOCK_H;

	draw_rect(frameBuf,
			  fx, fy,
			  fx + BLOCK_W -2, fy + BLOCK_H -2,
			  bcolors[cno]);
	draw_box(frameBuf,
			  fx, fy,
			  fx + BLOCK_W -2, fy + BLOCK_H -2,
			  0);
}

/* eg~m̕` */
void draw_tetorimino(unsigned int frameBuf[HEIGHT][WIDTH],
					 int x, int y, int mino, int rot) {
	TETORIMINO *m = minos[mino];
	char *p = &m->patterns[m->size * m->size * rot];
	int i, j;

	for (i = 0; i < m->size; i++) {
		for (j = 0; j < m->size; j++) {
			char b = *p++;
			if (b > 0) {
				draw_block(frameBuf, x + j, y + i, b);
			}
		}
	}
}

/* ̃eg~m */
void next_mino(void) {
	/* V𖞕ՂȂo*/
	TETORIMINO *m = minos[next];
	int cnt;
	int i, j;

	mino = next;
	bx = m->sx;
	by = m->sy + 1;
	rot = 0;

	reset_btimer();

	/* PȗƓubNJԂꍇ
	next = rand() % NUMBEROF(minos);
	*/

	/* V킪ꏄ܂ł́AubNoȂ悤ɂ */
	cnt = NUMBEROF(minos) - count % NUMBEROF(minos);
	if (cnt == NUMBEROF(minos)) {
		mino_mask = 0;
	}
	j = rand() % cnt;
	/*REPORT(format("cnt=%d, mask=%x, j=%d", cnt, mino_mask, j));/**/

	for (i = 0x01, next = 0; i < 0x80; i <<= 1, next++) {
		if (!(mino_mask & i)) {
			if (j-- <= 0) {
				mino_mask |= i;
				break;
			}
		}
	}
	/*REPORT(format("next=%d", next));/**/

	++count;
}

/* ubN̗^C}ݒ */
void reset_btimer(void) {

/*	btimer = BASE_DOWN_COUNT - level * FIXED_LEVEL; /**/

	if (level <= 5) {
		btimer = BASE_DOWN_COUNT >> (level - 1);
	} else {
		btimer = BASE_DOWN_COUNT >> (level - 5);
	}
	if (btimer < 0) btimer = 0;
}

/* tB[hƂ̐ڐG */
int check_field(int x, int y, int mino, int rot) {

	TETORIMINO *m = minos[mino];
	char *p = &m->patterns[m->size * m->size * rot];
	int i, j;

	for (i = 0; i < m->size; i++) {
		int my = y + i;

		for (j = 0; j < m->size; j++) {
			char b = *p++;
			if (b > 0) {
				int mx = x + j;

				/* ǂƂ̐ڐG`FbN */
				if (mx < 0 || my < 0
					|| mx >= FIELD_W || my >= FIELD_H) return -1;

				/* ȑÕubNƂ̐ڐG`FbN */
				if (field[my][mx] > 0) return -1;
			}
		}
	}

	return 0;
}

/* tB[hɃeg~mݒ */
void set_tetorimino(int x, int y, int mino, int rot) {

	TETORIMINO *m = minos[mino];
	char *p = &m->patterns[m->size * m->size * rot];
	int i, j;

	for (i = 0; i < m->size; i++) {
		int my = y + i;

		for (j = 0; j < m->size; j++) {
			char b = *p++;
			if (b > 0) {
				int mx = x + j;
				field[my][mx] = b;
				if (my < tline) {
					tline = my;
				}
			}
		}
	}

	if (tline <= HURRYUP_LINE) sound_music(BGM_HURRYUP, -1);
}

/* C𔻒 */
int check_line(int y, int mino, int rot) {

	TETORIMINO *m = minos[mino];
	char *p = &m->patterns[m->size * m->size * rot];
	int i, j, k;

	memset(clear_tbl, -1, sizeof(clear_tbl));
	clear_cnt = 0;

	for (i = 0; i < m->size; i++) {
		int my = y + i;

		for (j = 0; j < m->size; j++) {
			char b = *p++;
			if (b > 0) {
				char *f = field[my];

				for (k = 0; k < FIELD_W; k++) {
					if (f[k] == 0) break;
				}

				if (k == FIELD_W) {
					clear_tbl[clear_cnt] = my;
					memset(f, H, sizeof(char) * FIELD_W);
					++clear_cnt;
				}
				break;
			}
		}
	}

	if (clear_cnt > 0) {
		/* XRAvZ */
		int point = points[clear_cnt - 1];
		int rate = (FIELD_H - clear_tbl[0] -1) / RATE_INTERVAL + 1;

		score += point * rate;
		font_locate(POINTS_COL, POINTS_ROW);
		font_printf("% 4d*%d=%4d Points!", point, rate, point * rate);

	} else {
		font_locate(POINTS_COL, POINTS_ROW);
		font_printf("                    ");
	}

	return clear_cnt;
}

/* C */
void clear_line(void) {

	int i, j;

	/* C */
	for (i = 0; i < clear_cnt; i++) {
		int my = clear_tbl[i];

		for (j = my; j > 0; j--) {
			memcpy(field[j], field[j-1], sizeof(char) * FIELD_W);
		}
		memset(field[0], 0, sizeof(char) * FIELD_W);
	}

	switch (clear_cnt) {
	case 4:
		++line4;
		sound_effect(SE_TETORIS);
		break;
	case 3:
		++line3;
		sound_effect(SE_ERASE);
		break;
	case 2:
		++line2;
		sound_effect(SE_ERASE);
		break;
	default:
		++line1;
		sound_effect(SE_ERASE);
		break;
	}

	lines += clear_cnt;
	tline += clear_cnt;
	levelup_cnt += clear_cnt;

	if (levelup_cnt >= LEVELUP_COUNT) {
		++level;
		levelup_cnt = 0;
	}

	if (tline > HURRYUP_LINE) sound_music(BGM_GAME, -1);
}

/*  */
void reset(void) {

	REPORT("reset ... start.");

	scene_id = SCENE_ID_TITLE;

	font_clean();

	font_locate(START_COL, START_ROW);
	font_printf("Press space key to Start!");

	mino_mask = 0;
	tline = FIELD_H;

	score = 0;
	lines = 0;
	level = 1; /**/
/*	level = 12;/**/
	line4 = 0;
	line3 = 0;
	line2 = 0;
	line1 = 0;
	count = -1;
	levelup_cnt = 0;
	wtimer = -1;

	/*next = rand() % NUMBEROF(minos); /**/
	next_mino();
	next_mino();

	/* tB[h */
	memset(field, 0, sizeof(field));

/* TEST : Ƃ肠ubNŖ߂
	{
		int x, y;
		for (y = 0; y < FIELD_H; y++) {
			for (x = 0; x < FIELD_W; x++) {
				REPORT(format("x,y=%d,%d", x, y));
				field[y][x] = G;
			}
		}
	}
/**/

	sound_music(BGM_TITLE, -1);

	REPORT("reset ... done.");
}
